/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package common;

public final class FloatConverter<T extends Number> implements IConverter<T,Float> {

	public Float convert(T t) {
		return t.floatValue();
	}
	@Override
	public Float[] convert(T[] tarr) {
		Float[] retVal = new Float[tarr.length];
		for(int i = 0;i<retVal.length;i++)
			retVal[i] = convert(tarr[i]);
		return retVal;
	}
	@Override
	public void convert(T[] tarr,Float[] sarr) {
		for(int i = 0;i<sarr.length;i++)
			sarr[i] = convert(tarr[i]);
	}
}
