/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package math;
public interface IBasicOperations<T extends Number> {

	public T add(T x,T y);
	public T sub(T x,T y);
	public T mul(T x,T y);
	public T mul(T x,int i);
	public T div(T x,T y);
	public byte cmp(T x,T y);
	public T abs(T x);
	public byte sign(T x);
	public T mod(T x,T y);
	public T pow(T x,int ex);
	public T pow(T x,T y);
	public T sqrt(T x,int p);
	public T sqrt(T x);
	public T neg(T x);
	public T inv(T x);
	public T sin(T x);
	public T asin(T x);
	public T cos(T x);
	public T acos(T x);
	public T tan(T x);
	public T atan(T x);
	public T log(T x);
}
