/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package math;



public final class UtilDouble extends Util<Double> {
	public UtilDouble() {}
	@Override
	public int precision(Double x) {return 16;}
	@Override
	public Double copy(Double x, int p) {return x;}
	@Override
	public Double cast(int i) {return new Double(i);}
	@Override
	public Double cast(float f) {return new Double(f);}
	@Override
	public Double cast(double d) {return new Double(d);}
	@Override
	public Double parse(String s) {return new Double(s);}
	@Override
	public Double getPi(int digits) {return Math.PI;}
	@Override
	public Double[] array(int dim) {return new Double[dim];}
	@Override
	public Double[][] array(int d1,int d2) {return new Double[d1][d2];}
	@Override
	public int getScale(Double x) {return (int) (Math.floor(Math.log(x))+1);}
	@Override
	public Double round(Double x,int p) {
		if(p<16)
			return ((long)(x*Math.pow(10,p)+0.5))*Math.pow(10,-p);
		return x;
	}
	@Override
	public Double expand(Double x, int p) {return x;}
	@Override
	public int getErrorScale(Double x) {return -16;}
	@Override
	public Double getE(int digit) {return Math.E;}
}
