/**
	Copyright (c) 2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package mvc;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;

public class SimpleBorder implements IFZLBorder {

	private final int size;
	private Color color;

	SimpleBorder(int s,Color c){
		this.size = s;
		this.color = c;
	}
	@Override
	public void drawBorder(Component c, Graphics g) {
		g.setColor(color);
		g.fillRect(0,0,c.getWidth(),size);
		g.fillRect(0,c.getHeight()-size,c.getWidth(),size);
		g.fillRect(0,size,size,c.getHeight()-2*size);
		g.fillRect(c.getWidth()-size,size,size,c.getHeight()-2*size);
	}
	@Override
	public Insets getBorderInsets(Component c) {
		return new Insets(size,size,size,size);
	}
	@Override
	public void setColor(Color c) {
		color = c;
	}
}
