/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package parser;
import math.VecMath;

final class FunctionExpression<T extends Number> extends Expression<T> {

	private String f;
	FunctionExpression(String function,VecMath<T> math) {
		super(math);
		this.f = function;
	}
	T getValue() throws Exception {
		if(getChildCount()==0)
			throw new Exception("Function "+f+" has no arguments.");
		else if(getChildCount()>1)
			throw new Exception("Function "+f+" has more than one argument.");
		T retVal = null;
		T arg = getChild(0).getValue();
		if(f.compareTo(Symbols.SINE)==0)
			retVal = math.sin(arg);
		else if(f.compareTo(Symbols.COSINE)==0)
			retVal = math.cos(arg);
		else if(f.compareTo(Symbols.TAN)==0)
			retVal = math.tan(arg);
		else if(f.compareTo(Symbols.ARCSINE)==0)
			retVal = math.asin(arg);
		else if(f.compareTo(Symbols.ARCCOSINE)==0)
			retVal = math.acos(arg);
		else if(f.compareTo(Symbols.ARCTAN)==0)
			retVal = math.atan(arg);
		else if(f.compareTo(Symbols.LOG)==0)
			retVal = math.log(arg);
		else if(f.compareTo(Symbols.SQRT)==0)
			retVal = math.sqrt(arg);
		return retVal;
	}
}
