/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package parser;
import java.util.ArrayList;

public class Symbols {

	public static final String SINE = "sin";
	public static final String COSINE = "cos";
	public static final String TAN = "tan";
	public static final String ARCSINE = "arcsin";
	public static final String ARCCOSINE = "arccos";
	public static final String ARCTAN = "arctan";
	public static final String SQRT = "sqrt";
	public static final String LOG = "ln";
	public static final String[] FUNCTIONS = new String[]{SINE,COSINE,TAN,ARCSINE,ARCCOSINE,ARCTAN,
	        SQRT,LOG};
	public static final String FAC = "!";
	public static final String MUL = "*";
	public static final String DIV = "/";
	public static final String ADD = "+";
	public static final String SUB = "-";
	public static final String POW = "^";
	public static final String[] OPERATORS = new String[]{FAC,POW,DIV,MUL,SUB,ADD};
	public static final String EULER = "e";
	public static final String PI = "pi";
	public static final String REFERENCE = "$";
	public static final String DELIMITER = ",";
	public static final int[] precedence(ArrayList<String> op) {
		int[] retVal = new int[op.size()];
		int idx = 0;
		for(int i = 0;i<OPERATORS.length;i++)
			for(int k = 0;k<op.size();k++)
				if(OPERATORS[i].compareTo(op.get(k))==0)
					retVal[idx++] = k;
		return retVal;
	}
	public static final boolean isUnary(String op) {
		if(op.compareTo(FAC)==0)
			return true;
		return false;
	}
	public static boolean isFunction(String name) {
		for(String f:Symbols.FUNCTIONS)
			if(name.compareTo(f)==0)
				return true;
		return false;
	}
}
