/**
	Copyright (c) 2009-2013 by Zoltan Palmer

	This file is part of FroZenLight.

    FroZenLight is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FroZenLight is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FroZenLight.  If not, see http://www.gnu.org/licenses/
*/
package pattern;
import java.util.ArrayList;

public class LightChar extends LightPatternSequence implements Comparable<LightChar> {

	public static boolean HORIZONTAL = false;
	public static boolean VERTICAL = true;
	private String character;
	private boolean orientation;
	public LightChar(String cr) {
		this.character = cr;
		this.orientation = HORIZONTAL;
	}
	public LightChar copy() {
		LightChar s = new LightChar(this.character);
		s.m_init = new ArrayList<Float>(m_init);
		s.cells = new ArrayList<short[]>();
		for(int i = 0;i<this.cells.size();i++)
			s.cells.add(this.cells.get(i).clone());
		return s;
	}
	public String getChar() {
		return character;
	}
	public void move(short dx,short dy) {
		for(int i = 0;i<cells.size();i++) {
			cells.get(i)[0] += dx;
			cells.get(i)[1] += dy;
		}
	}
	public void setOrientation(boolean ori) {
		this.orientation = ori;
	}
	public boolean getOrientation() {
		return orientation;
	}
	@Override
	public int compareTo(LightChar lc) {

		if(!Character.isLetter(character.toCharArray()[0]))
			return 1;
		else if(!Character.isLetter(lc.getChar().toCharArray()[0]))
			return -1;
		if(character.length()<lc.getChar().length())
			return -1;
		else if(character.length()>lc.getChar().length())
			return 1;		
		return character.compareTo(lc.getChar());
	}
}